﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using HeuristicLab.Services.Hive.DataAccess;
using HeuristicLab.Services.Hive.Tests.Mocks;

namespace HeuristicLab.Services.Hive.Tests {
  internal class MockServiceLocator : IServiceLocator {

    private IServiceLocator defaultServiceLocator;
    public MockServiceLocator(IServiceLocator defaultServiceLocator) {
      this.defaultServiceLocator = defaultServiceLocator;
    }

    public IAuthenticationManager AuthenticationManager {
      get { return new MockAuthenticationManager(); }
    }

    //private MockAuthorizationManager mockAuthorizationManager = new MockAuthorizationManager();
    public IAuthorizationManager AuthorizationManager {
      get { return defaultServiceLocator.AuthorizationManager; }
    }

    public IHiveDao HiveDao {
      get { return defaultServiceLocator.HiveDao; }
    }

    public ILifecycleManager LifecycleManager {
      get { return defaultServiceLocator.LifecycleManager; }
    }
    public ITransactionManager TransactionManager {
      get { return defaultServiceLocator.TransactionManager; }
    }
    private MockUserManager mockUserManager = new MockUserManager();
    public IUserManager UserManager {
      get { return mockUserManager; }
    }
    public HeartbeatManager HeartbeatManager {
      get { return defaultServiceLocator.HeartbeatManager; }
    }

    #region Special mocking methods
    public void SetCurrentUserId(Guid userId) {
      mockUserManager.SetUserId(userId);
    }
    #endregion
  }
}
